Bug 428964 - RHEL4.7: HDMI Audio support for AMD ATI chipsets
RHEL4.7: HDMI Audio support for AMD ATI chipsets
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.7
All Linux
high Severity urgent
: rc
: ---
Assigned To: Bhavna Sarathy
Martin Jenner
: HardwareEnablement, OtherQA
Depends On: 314391
Blocks: 335381 RHEL4u7_relnotes 456097 456155
  Show dependency treegraph
 
Reported: 2008-01-16 10:03 EST by Bhavna Sarathy
Modified: 2009-06-19 22:06 EDT (History)
15 users (show)

See Also:
Fixed In Version: RHSA-2008-0665
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-07-24 15:24:43 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
patch for ATI HDMI Device ID (1.69 KB, patch)
2008-06-09 22:56 EDT, Yang, Libin
no flags Details | Diff
The updated patch for HDMI Device ID (1.67 KB, patch)
2008-06-09 23:11 EDT, Yang, Libin
no flags Details | Diff
dmesg in kernel 2.6.9-73 with EHCI failure (15.56 KB, text/plain)
2008-07-17 23:16 EDT, Shane Huang
no flags Details
/proc/interrupts in kernel 2.6.9-72 (519 bytes, text/plain)
2008-07-17 23:18 EDT, Shane Huang
no flags Details
/proc/interrupts in kernel 2.6.9-73 (520 bytes, text/plain)
2008-07-17 23:21 EDT, Shane Huang
no flags Details
Fix the IRQ request bug involved when RH backport alsa-driver (857 bytes, patch)
2008-07-18 03:52 EDT, Shane Huang
no flags Details | Diff
Removing the ATI HDMI IDs as a workaround, not encouraged (1.72 KB, patch)
2008-07-18 04:28 EDT, Shane Huang
no flags Details | Diff

  None (edit)
Description Bhavna Sarathy 2008-01-16 10:03:48 EST
+++ This bug was initially created as a clone of Bug #428963 +++

Add HDMI support for AMD ATI chipsets to allow HDMI to work on a wide variety of
chipsets.   The patch is for RS780, RV610, RV620, RV630, RV635, RV670, RV770. 
The patch has been tested on RV610, RV630 and with the patch it works correctly. 

The next stable/unstable release of also-sriver right after version 1.0.15 will
include it, and the patch can already be found in the alsa-driver daily snapshot.
Comment 1 RHEL Product and Program Management 2008-01-16 10:17:14 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 3 Bhavna Sarathy 2008-02-19 14:50:27 EST
Jaroslav,

Does RHEL4 code base support HDMI audio support?   I couldn't find the following
files that we would have to modify to add the ATI HDMI support.

sound/pci/hda/hda_intel.c
sound/pci/hda/patch_atihdmi.c

Are there any upstream links that we would have to backport?

This is the patch that AMD would need in RHEL4.7.

--- linux-2.6.18.x86_64/sound/pci/hda/patch_atihdmi.c.hdmiorig	2008-01-17
11:24:03.000000000 -0500
+++ linux-2.6.18.x86_64/sound/pci/hda/patch_atihdmi.c	2008-01-17
13:14:17.000000000 -0500
@@ -161,6 +161,7 @@
  */
 struct hda_codec_preset snd_hda_preset_atihdmi[] = {
 	{ .id = 0x1002793c, .name = "ATI RS600 HDMI", .patch = patch_atihdmi },
-	{ .id = 0x1002791a, .name = "ATI RS690 HDMI", .patch = patch_atihdmi },
-	{} /* terminator */
+	{ .id = 0x1002791a, .name = "ATI RS690/780 HDMI", .patch = patch_atihdmi },
+	{ .id = 0x1002aa01, .name = "ATI R6xx HDMI", .patch = patch_atihdmi },
+        {} /* terminator */
 };
--- linux-2.6.18.x86_64/sound/pci/hda/hda_intel.c.hdmiorig	2008-01-17
11:23:52.000000000 -0500
+++ linux-2.6.18.x86_64/sound/pci/hda/hda_intel.c	2008-01-17 11:28:20.000000000
-0500
@@ -88,6 +88,14 @@
 			 "{ATI, SB600},"
 			 "{ATI, RS600},"
 			 "{ATI, RS690},"
+			 "{ATI, RS780},"
+			 "{ATI, R600},"
+			 "{ATI, RV630},"
+			 "{ATI, RV610},"
+			 "{ATI, RV670},"
+			 "{ATI, RV635},"
+			 "{ATI, RV620},"
+			 "{ATI, RV770},"
 			 "{VIA, VT8251},"
 			 "{VIA, VT8237A},"
 			 "{SiS, SIS966},"
@@ -1758,6 +1766,14 @@
 	{ 0x1002, 0x4383, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_ATI }, /* ATI SB600 */
 	{ 0x1002, 0x793b, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_ATIHDMI }, /* ATI
RS600 HDMI */
 	{ 0x1002, 0x7919, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_ATIHDMI }, /* ATI
RS690 HDMI */
+	{ 0x1002, 0x960f, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_ATIHDMI }, /* ATI
RS780 HDMI */
+	{ 0x1002, 0xaa00, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_ATIHDMI }, /* ATI
R600 HDMI */
+	{ 0x1002, 0xaa08, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_ATIHDMI }, /* ATI
RV630 HDMI */
+	{ 0x1002, 0xaa10, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_ATIHDMI }, /* ATI
RV610 HDMI */
+	{ 0x1002, 0xaa18, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_ATIHDMI }, /* ATI
RV670 HDMI */
+	{ 0x1002, 0xaa20, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_ATIHDMI }, /* ATI
RV635 HDMI */
+	{ 0x1002, 0xaa28, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_ATIHDMI }, /* ATI
RV620 HDMI */
+	{ 0x1002, 0xaa30, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_ATIHDMI }, /* ATI
RV770 HDMI */
 	{ 0x1106, 0x3288, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_VIA }, /* VIA
VT8251/VT8237A */
 	{ 0x1039, 0x7502, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_SIS }, /* SIS966 */
 	{ 0x10b9, 0x5461, PCI_ANY_ID, PCI_ANY_ID, 0, 0, AZX_DRIVER_ULI }, /* ULI M5461 */


Bhavana


Comment 4 Bhavna Sarathy 2008-02-19 16:17:36 EST
Brian, you mentione hda_intel and AZX in your  codec update.   See comment #3,
does your 4.6 patch help us get that base support so that patch above can be
submitted to 4.7?
Comment 5 Brian Maly 2008-02-19 17:00:39 EST
Yes, it should.
Comment 6 Bhavna Sarathy 2008-02-28 16:06:23 EST
OK, great, let me know once there is a source I can work off of for the HDMI
audio patch.
Comment 7 Russell Doty 2008-03-11 14:38:33 EDT
Updated summary to clarify that this is an HDMI Audio issue.
Comment 8 Bhavna Sarathy 2008-03-17 16:26:14 EDT
Posted patch to RHML on Mar 17.  RHEL RPM testing pending Brian's 20K ALSA patch
being incorporated into RHEL4.7 code base.  
Comment 10 Shane Huang 2008-03-26 23:15:40 EDT
Bhavana,

Does it mean that RHEL4.7 will support HDMI once Brian's 20K ALSA patch has 
been incorporated?

Can you notify us as soon as possible when Brian's patch is ready and new 
kernel rpm package is available too?

Thanks
Comment 11 Vivek Goyal 2008-05-16 13:51:31 EDT
Committed in 70.EL. RPMS are available at http://people.redhat.com/vgoyal/
Comment 14 Shane Huang 2008-05-27 22:21:50 EDT
The device IDs have been added into sound/pci/azx/hda_intel.c of 2.6.9-70,
but it seems that RHEL4 itself does not support HDMI audio well?

Am I right? Is there any guy who can confirm the HDMI audio support of RHEL4.7?

Thanks
Comment 15 Shane Huang 2008-06-04 02:38:24 EDT
Bhavana,

Can you help to check with Red Hat whether RHEL4.7 itself support HDMI audio 
or not?

Thanks
Comment 16 Chris Ward 2008-06-05 11:49:50 EDT
~~~~~~~~~~~~~~
~ Attention: ~ Feedback requested regarding this **High Priority** bug. 
~~~~~~~~~~~~~~

A fix for this issue should be included in the latest packages contained in
RHEL4.7-Snapshot1--available now on partners.redhat.com.

After you (Red Hat Partner) have verified that this issue has been addressed,
submit a comment describing the passing results of your test in appropriate
detail, along with which snapshot and package version tested. The bugzilla will
be updated by Red Hat Quality Engineering for you when this information has been
received.

If you believe this issue has not properly fixed or you are unable to verify the
issue for any reason, please add a comment describing the most recent issues you
are experiencing, along with which snapshot and package version tested. 

If you believe the bug has not been fixed, change the status of the bug to ASSIGNED.

If you are receiving this message in Issue Tracker, please reply with a message
to Issue Tracker about your results and bugzilla will be updated for you. 

If you need assistance accessing ftp://partners.redhat.com, please contact your
Partner Manager.

Thank you
Red Hat QE Partner Management
Comment 17 Yang, Libin 2008-06-09 22:56:34 EDT
Created attachment 308764 [details]
patch for ATI HDMI Device ID
Comment 18 Yang, Libin 2008-06-09 22:58:36 EDT
I have updated a patch for Device ID. Please check.
Comment 19 Yang, Libin 2008-06-09 23:11:13 EDT
Created attachment 308765 [details]
The updated patch for HDMI Device ID
Comment 21 Jaroslav Kysela 2008-06-10 07:35:52 EDT
All mentioned PCI IDs are already in upstream. Ack from me.
Comment 22 Chris Ward 2008-06-10 07:44:18 EDT
AMD, the issues in this bug should have been addressed in the RHEL4U7 Beta or
the latest snapshot 1, available at partners.redhat.com? Could you please verify
this and report back your testing results here?
Comment 23 Bhavna Sarathy 2008-06-10 09:39:25 EDT
The testing results and the need for the patch reflects snapshot 1 testing 
results.   RHEL4.7 code base is missing the patch in comment #19.
Comment 24 Bhavna Sarathy 2008-06-10 14:43:54 EDT
Submitted to RHML 6/10 and received 2 ACKs.
Comment 25 Shane Huang 2008-06-10 21:19:54 EDT
So, which kernel version is expected to include the patch in comment #19?
Is it 2.6.9-73?  Thanks
Comment 26 Vivek Goyal 2008-06-12 14:31:03 EDT
Committed in 73.EL . RPMS are available at http://people.redhat.com/vgoyal/rhel4/
Comment 28 Yang, Libin 2008-06-12 23:11:38 EDT
Smoke test on 73.EL has been done. It has included the patch in comment #19. 
It works. Thanks.
Comment 33 Shane Huang 2008-07-17 23:08:09 EDT
The HDMI patch leads to USB EHCI failure on AMD SB700, which lead to very
low performance to USB 2.0 devices such as external USB HDD.

The interrupt 201 will be occupied by HDA, so ehci failed to request it.

Here are the dmesg and /proc/interrupts.
Comment 34 Shane Huang 2008-07-17 23:16:26 EDT
Created attachment 312095 [details]
dmesg in kernel 2.6.9-73 with EHCI failure
Comment 35 Shane Huang 2008-07-17 23:18:47 EDT
Created attachment 312096 [details]
/proc/interrupts in kernel 2.6.9-72
Comment 36 Shane Huang 2008-07-17 23:21:21 EDT
Created attachment 312097 [details]
/proc/interrupts in kernel 2.6.9-73
Comment 37 Shane Huang 2008-07-18 03:50:46 EDT
We found out the root cause:
There is one bug when RedHat backported alsa driver to RHEL4.7,
IRQF_SHARED in alsa-driver should NOT be replaced into 0x00000080 simply,
instead, SA_SHIRQ should be used for old kernel versions like 2.6.9.
Please re-check your alsa-driver backport.

The patch below can fix the bug, which has been tested on SB700.
Please add it to RHEL4.7 ASAP before its release, otherwise there will be
many bugs besides the USB EHCI one reported above. Thanks.
Comment 38 Shane Huang 2008-07-18 03:52:26 EDT
Created attachment 312106 [details]
Fix the IRQ request bug involved when RH backport alsa-driver
Comment 39 Shane Huang 2008-07-18 04:26:30 EDT
If RH still have some concern to add the fix patch above due to the coming
RHEL4.7 release, please make sure the ATI HDMI device IDs must be withdrawn
with the patch below to make USB EHCI work in RHEL4.7, and also update your
release note if necessary that RHEL4.7 not supporting ATI HDMI audio.

But this method is a workaround with little risk, not the solution.
We strongly suggest RH can accept the IRQ bug fix above ASAP for RHEL 4.7.
Thanks.
Comment 40 Shane Huang 2008-07-18 04:28:15 EDT
Created attachment 312108 [details]
Removing the ATI HDMI IDs as a workaround, not encouraged
Comment 42 Shane Huang 2008-07-20 21:45:32 EDT
Is there any RH guy who are checking the bug in comment #33 and our fix?
Comment 43 Chris Ward 2008-07-21 06:02:09 EDT
AMD, the issues in Comment #33 are currently being reviewed. Thanks for the
information. We'll report back with more as soon as possible.
Comment 46 Chris Ward 2008-07-21 12:07:33 EDT
AMD, it appears, due to the unexpected issues found during testing, that this
bug will not be going into the RHEL4.7 update. Sorry for the bad news. 

Thanks again though for sending us your detailed testing results. We'll work on
addressing this issue as soon as possible. Your patch is currently being reviewed.

A request to include it in the next update release (4.8) has already been
submitted. 
Comment 47 RHEL Product and Program Management 2008-07-21 12:12:18 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 49 Linda Wang 2008-07-21 15:54:20 EDT
Bug 456155 is to address the change needed to fix the feature in 4.8.
Please see bug 456155 for more detailed info.
Comment 51 John Feeney 2008-07-21 17:02:52 EDT
I created rpms with the patch found in comment #38 so it can be tested as
soon as possible by all effected partners. Please find these rpms at
http://people.redhat.com/jfeeney/.bz428964_454479 

Note: the fix for bz454479 is also included in these rpms.
Comment 54 Shane Huang 2008-07-22 05:52:24 EDT
We did some USB and HDMI test with the above testing kernel
(2.6.9-77.EL.jfeeney.454479.2):

The USB EHCI bug has been fixed and HDMI still can work,
We do not find any regression issue either so far, the test result
of overnight USB stress test will come out tomorrow.
Comment 55 Jaroslav Kysela 2008-07-22 08:23:13 EDT
Shane, I am planning to do a big ALSA HDA driver update for RHEL 4.8. Could you
test also kernels in bug#452846 (hdaUpdate3)? These kernels contains latest ALSA
HDA driver code. Thank you.
Comment 56 Shane Huang 2008-07-22 21:19:42 EDT
Jaroslav, my comment has been added to the BZ #452846, please check it.
Comment 57 errata-xmlrpc 2008-07-24 15:24:43 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2008-0665.html
Comment 58 Chris Ward 2008-07-29 03:28:44 EDT
Partners, I would like to thank you all for your participation in assuring the
quality of this RHEL 4.7 Update Release. My hat's off to you all. Thanks.

Note You need to log in before you can comment on or make changes to this bug.